# updated by AC for AC3D 8

proc ddhbasrelief_makeframe { parent } {
	global UI


   # CUSTOM CONFIGURATION: Change these values to set the number of characters
   #                       wide * high to show the texture list box
   set lwidth 48
   set lheight 12

   # Object size vars
   set objsizmin 0.1
   set objsizmax 100.0
   set objsizinc 0.1

   # Height vars
   set heightmin 0.01
   set heightmax 100.0
   set heightinc 0.1



   set width 6
   set ypad 3

   # List of textures
   ttk::frame $parent.frmlist
   pack $parent.frmlist -side top -fill both -expand 1
   ttk::label $parent.frmlist.ttl -text "Texture for bas relief"
   pack $parent.frmlist.ttl -side top -fill x
   set UI(ddhbasrelieflisttex) [ listbox $parent.frmlist.listtex -height $lheight -width $lwidth -yscrollcommand "$parent.frmlist.listtexscroll set" ]
   set listwidget $UI(ddhbasrelieflisttex)

   ac_scrollbar $parent.frmlist.listtexscroll -orient vertical -command { $parent.frmlist.listtex yview }
   pack $parent.frmlist.listtex -side left -fill both -expand 1
   pack $parent.frmlist.listtexscroll -side right -fill y

   # Space
   ttk::frame $parent.frmspace1
   pack $parent.frmspace1 -side top -fill x -pady $ypad

   # Size of the resulting object
   set frm [ttk::frame $parent.frmobjsiz]
   pack $frm -side top -fill x
   ttk::label $frm.lbl -text "Maximum width/depth"
   pack $frm.lbl -side left -fill x
   ttk::spinbox $frm.sbx -from $objsizmin -increment $objsizinc -to $objsizmax -textvariable ddhbasrelief_objsiz -width $width
   pack $frm.sbx -side right -fill x
   add_balloon $frm.lbl "Maximum size of the resulting object along the X/Z axes."

   # Maximum height
   set frm [ttk::frame $parent.frmheight]
   pack $frm -side top -fill x
   ttk::label $frm.lbl -text "Maximum height"
   pack $frm.lbl -side left -fill x
   ttk::spinbox $frm.sbx -from $heightmin -increment $heightinc -to $heightmax -textvariable ddhbasrelief_height -width $width
   pack $frm.sbx -side right -fill x
   add_balloon $frm.lbl "Maximum size of the resulting object along the Y axis."

   # Space
   ttk::frame $parent.frmspace2
   pack $parent.frmspace2 -side top -fill x -pady $ypad

   # Go
   ttk::frame $parent.frmbtn
   pack $parent.frmbtn -side top -fill x

		proc create_grid { listw } {  
			global ddhbasrelief_objsiz
			global ddhbasrelief_height
			global ddhbasrelief_maxsiz
    
		  if { [ $listw curselection ] == "" } {
			 tk_messageBox -message "Please select a texture" -type ok -icon warning
			 return
		  }
		  set idx [$listw curselection]
		  eval ac3d ddhbasrelief_go $idx $ddhbasrelief_objsiz $ddhbasrelief_height $ddhbasrelief_maxsiz
#		  destroy $parent
	   }

   ttk::button $parent.frmbtn.btnapply -text "Create grid" -command "create_grid $listwidget"

   pack $parent.frmbtn.btnapply -side left -fill x -expand 1


}

proc ddhbasrelief_dialog {} {

   global ac_platform
   global UI
   global ddhbasrelief_objsiz
   global ddhbasrelief_height
   global ddhbasrelief_maxsiz

   set ddhbasrelief_objsiz 1.0
   set ddhbasrelief_height 0.1
   # MAXIMUM SIZE OF AN IMAGE (width * height)
   # This is the maximum number of vertices that will be created from a texture.
   # Change at your own risk.
   set ddhbasrelief_maxsiz 65536


   ac_toplevel_with_close .ddhbasrelief "Bas relief from texture" ddhbasrelief_makeframe

   return

   if ![winfo exists .ddhbasrelief] {
      ddhbasrelief_makeframe
   }

   wm deiconify .ddhbasrelief
   centre_window_on_screen .ddhbasrelief
   if { $ac_platform == "Mac" } {
	   update idletasks
	   exposeUI .ddhbasrelief
   }

   tkwait visibility .ddhbasrelief
   grab .ddhbasrelief

}

