


proc viewbutton {name label value } {
    ac_radiobutton $name -text $label -command configure_views -value $value \
    -variable viewsetting -indicatoron false -highlightthickness 0
}

# counter of buttons in toolbar
set toolbarbc 0

proc toolbar_add_button { label command help { icon "" } { width -4} } {
global toolbarbc UI

	set b [ac_button $UI(toolbar).$toolbarbc -text $label -command $command -width $width -takefocus 0 ]
    add_balloon $b $help
    
    if { $icon != ""} {
		image create photo photo$toolbarbc -file $icon 
		$b configure -width [ image width photo$toolbarbc ] -image photo$toolbarbc
	}
	
	pack $b -side left -padx 0 -pady 0 

	incr toolbarbc
	return $b
}


proc toolbar_add_space { } {
global toolbarbc UI

    set l [ac_label $UI(toolbar).$toolbarbc -text ""]
	pack $l -side left -padx 0 -pady 1

	incr toolbarbc
	return $l
}

proc toolbar_add_label { text } {
global toolbarbc UI

    set l [ac_label $UI(toolbar).$toolbarbc -text $text]
	pack $l -side left -padx 1 -pady 1

	incr toolbarbc
	return $l
}




proc populate_toolbar { } {
global UI ac_platform
global prefs_show_render_button prefs_sergio_ui_mode

#    toolbar_add_space

    # render button



	image create photo viewtopleft -file "tcl/images/viewtopleft.png"
	image create photo viewtopright -file "tcl/images/viewtopright.png"
	image create photo viewbottomleft -file "tcl/images/viewbottomleft.png"
	image create photo viewbottomright -file "tcl/images/viewbottomright.png"
	image create photo viewall -file "tcl/images/viewall.png"
		
	mode_button $UI(toolbar).all "ALL" configure_views viewsetting all "Tile all windows \[F5]" false "viewall"
	mode_button $UI(toolbar).xyz "3" configure_views viewsetting xyz  "bottom-right view \[F4]" false "viewbottomright"
	mode_button $UI(toolbar).xy "0" configure_views viewsetting xy "top-left view \[F1]" false "viewtopleft"
	mode_button $UI(toolbar).zy "1" configure_views viewsetting zy "top-right view \[F2]" false "viewtopright"
	mode_button $UI(toolbar).xz "2" configure_views viewsetting xz  "bottom-left \[F3]" false "viewbottomleft"

	set sp 1
	pack $UI(toolbar).all -side right -padx $sp
	pack $UI(toolbar).xyz -side right  -padx $sp
	pack $UI(toolbar).xz -side right  -padx $sp
	pack $UI(toolbar).zy -side right -padx $sp
	pack $UI(toolbar).xy -side right -padx $sp


	# UNDO and REDO buttons in toolbar (different unicode text for windows/unix)
	if { $ac_platform == "Windows" } {
		set UI(toolbar_undo) [ toolbar_add_button "\u2b8c" "ac3d undo" "Undo (Ctrl+Z)" "" 3 ]
		set UI(toolbar_redo) [ toolbar_add_button "\u2b8e" "ac3d redo" "Redo (Ctrl+Y / Ctrl+Shift+Z)" "" 3 ]
	} else {
		set UI(toolbar_undo) [ toolbar_add_button "\u21a9" "ac3d undo" "Undo (Control-Z)" "" 3 ]
		set UI(toolbar_redo) [ toolbar_add_button "\u21aa" "ac3d redo" "Redo (Control-Y / Control-Shift-Z)" "" 3 ]
	}


	if { !$prefs_sergio_ui_mode } { 
	


#		toolbar_add_button "\u2936" "ac3d undo" "Undo (Control-Z)"
#		toolbar_add_button "\u2937" "ac3d redo" "Redo (Control-Y / Control-Shift-Z)"
#		toolbar_add_button "\u293e" "ac3d undo" "Undo (Control-Z)"
#		toolbar_add_button "\u293f" "ac3d redo" "Redo (Control-Y / Control-Shift-Z)"
#		toolbar_add_button "\u293a" "ac3d undo" "Undo (Control-Z)"
#		toolbar_add_button "\u293b" "ac3d redo" "Redo (Control-Y / Control-Shift-Z)"
#		toolbar_add_button "\u2b6e" "ac3d undo" "Undo (Control-Z)"
#		toolbar_add_button "\u2b6f" "ac3d redo" "Redo (Control-Y / Control-Shift-Z)"
#		toolbar_add_button "\u21b1" "ac3d undo" "Undo (Control-Z)"
#		toolbar_add_button "\u21bb" "ac3d redo" "Redo (Control-Y / Control-Shift-Z)"
#		toolbar_add_button "\u21b6" "ac3d undo" "Undo (Control-Z)"
#		toolbar_add_button "\u21b7" "ac3d redo" "Redo (Control-Y / Control-Shift-Z)"

		toolbar_add_space

		toolbar_add_button "All" "ac3d select_all" "Select everything (Ctrl+A)"
		toolbar_add_button "None" "ac3d clear_selection" "Unselect everything (Ctrl+Shift+A)"

		toolbar_add_space

		toolbar_add_button "Dup" "ac3d duplicate" "Duplicate selection (Ctrl-D)"
	
		toolbar_add_space
	
		toolbar_add_button "Cut" "ac3d clipboard_cut" "Cut the selection to the clipboard (Ctrl+X)"
		toolbar_add_button "Copy" "ac3d clipboard_copy" "Copy the selection to the clipboard (Ctrl+C)"
		toolbar_add_button "Paste" "ac3d clipboard_paste" "paste a copy of the clipboard\nand make it the selection (Ctrl+V)"

		toolbar_add_space

		set UI(function_group) [toolbar_add_button "Group"  "ac3d group" "Create a group object with selected as children"]
		set UI(function_ungroup) [toolbar_add_button  "Ungroup"  "ac3d ungroup" "Destroy group object leaving children"]

		toolbar_add_label "Flip:"

		set UI(function_mirror_x) [toolbar_add_button  "X"  "ac3d mirror 0" "Flip selected about X axis" "" 2]
		set UI(function_mirror_y) [toolbar_add_button  "Y"  "ac3d mirror 1" "Flip selected about Y axis" "" 2]
		set UI(function_mirror_z) [toolbar_add_button  "Z"  "ac3d mirror 2" "Flip selected about Z axis" "" 2]
    
		toolbar_add_space


		toolbar_add_button "50%" "ac3d scale 0.5 0.5 0.5" "Half size of selected\n(key = { )"
		toolbar_add_button "200%" "ac3d scale  2.0 2.0 2.0" "Double size of selected\n(Key = } )"

		toolbar_add_button  "-10%" "ac3d scale 0.9 0.9 0.9" "Decrease size of selected\n(key = \[)"
		toolbar_add_button  "+10%" "ac3d scale 1.1 1.1 1.1" "Increase size of selected\n(key = \])"


		toolbar_add_space

		toolbar_add_button "SubD +" "ac3d adjust_subdivision_level 1" "Increase subdivision level on selected objects"
		toolbar_add_button "SubD -" "ac3d adjust_subdivision_level -1" "Decrease subdivision level on selected objects"
	}

	if { $prefs_sergio_ui_mode } {

		toolbar_add_button "All" "ac3d select_all" "select everything" tcl/images/toolbar/selectall.png
		toolbar_add_button "None" "ac3d clear_selection" "unselect everything" tcl/images/toolbar/selectnone.png

		toolbar_add_space

		toolbar_add_button "Dup" "ac3d duplicate" "make another copy of the selection" tcl/images/toolbar/duplicate.png
	
		toolbar_add_space
	
		toolbar_add_button "Cut" "ac3d clipboard_cut" "Cut the selection to the clipboard" tcl/images/toolbar/cut.png
		toolbar_add_button "Copy" "ac3d clipboard_copy" "Copy the selection to the clipboard" tcl/images/toolbar/copy.png
		toolbar_add_button "Paste" "ac3d clipboard_paste" "paste a copy of the clipboard\nand make it the selection" tcl/images/toolbar/paste.png

		toolbar_add_space

		set UI(function_group) [toolbar_add_button "Group"  "ac3d group" "Create a group object with selected as children" tcl/images/toolbar/group.png]
		set UI(function_ungroup) [toolbar_add_button  "Ungroup"  "ac3d ungroup" "Destroy group object leaving children" tcl/images/toolbar/ungroup.png]

		toolbar_add_space
	
		toolbar_add_label "Flip:"
	
		set UI(function_mirror_x) [toolbar_add_button  "X"  "ac3d mirror 0" "Flip selected about X axis" tcl/images/toolbar/flipx.png]
		set UI(function_mirror_y) [toolbar_add_button  "Y"  "ac3d mirror 1" "Flip selected about Y axis" tcl/images/toolbar/flipy.png]
		set UI(function_mirror_z) [toolbar_add_button  "Z"  "ac3d mirror 2" "Flip selected about Z axis" tcl/images/toolbar/flipz.png]
    
		toolbar_add_space

	
		toolbar_add_button "50%" "ac3d scale 0.5 0.5 0.5" "Half size of selected\n(key = { )" tcl/images/toolbar/scale0.5.png
		toolbar_add_button "200%" "ac3d scale  2.0 2.0 2.0" "Double size of selected\n(Key = } )" tcl/images/toolbar/scale2.0.png

		toolbar_add_button  "-10%" "ac3d scale 0.9 0.9 0.9" "Decrease size of selected\n(key = \[)" tcl/images/toolbar/scale0.9.png
		toolbar_add_button  "+10%" "ac3d scale 1.1 1.1 1.1" "Increase size of selected\n(key = \])" tcl/images/toolbar/scale1.1.png


		toolbar_add_space

		toolbar_add_button "Subdiv +" "ac3d adjust_subdivision_level 1" "Increase subdivision level on selected objects" tcl/images/toolbar/subdivincrease.png
		toolbar_add_button "Subdiv -" "ac3d adjust_subdivision_level -1" "Decrease subdivision level on selected objects" tcl/images/toolbar/subdivdecrease.png
	}

	set UI(renderbutton) [toolbar_add_button "Render..." {puts [do_render]} "Call tools->render directly"]

	# pack the render button now?
	if { $prefs_show_render_button } {
		pack $UI(renderbutton) -side left
	} else {
		pack forget $UI(renderbutton)
	}

}







